



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Python的高级特性11:拓展基本数据类型(dict)</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Python的高级特性11:拓展基本数据类型(dict)</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-28 13:43:48 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>字典的创建有两种方式,如果出现In [26]这样的赋值方式就会报错。</p>
<div>
<pre class="prettyprint linenums">In [17]: s['name'] = 'alex'

In [18]: s['sex'] = 'male'

In [19]: s<br />
Out[19]: {'name': 'alex', 'sex': 'male'}

In [20]: s = {'name':'alex','sex':'male'}

In [21]: s<br />
Out[21]: {'name': 'alex', 'sex': 'male'}

In [22]: t = {}

In [23]: t['name'] = 'lilei'

In [24]: t['sex'] = 'male'

In [25]: t<br />
Out[25]: {'name': 'lilei', 'sex': 'male'}

In [26]: t.name = 'hanmeimei'<br />
---------------------------------------------------------------------------<br />
AttributeError                            Traceback (most recent call last)<br />
&lt;ipython-input-26-62e0b27ded5b&gt; in &lt;module&gt;()<br />
----&gt; 1 t.name = 'hanmeimei'

AttributeError: 'dict' object has no attribute 'name'</pre>
</div>
<p>但我这个人很固执,就对这种方式情有独钟，迫切希望Python可以拓展这个属性,该怎么办呢？最好的办法就是自己来拓展。</p>
<p>t.name = 'hanmeimei' 这样的set方式明显是__setter__行为,那么我只需要重写__setter__方法就可以了。</p>
<div>
<pre class="prettyprint linenums">class StrongerDict(dict):<br />
    def __getattr__(self, key):<br />
        return self[key]

    def __setattr__(self, key, value):<br />
        self[key] = value

    def __call__(self, key):<br />
        return self[key]

s = StrongerDict()<br />
#__setattr__方法<br />
s.name = 'alex'<br />
#dict本身赋值方法不受影响，因为重写的是__setattr__方法<br />
s['sex'] = 'male'<br />
print(s)<br />
#__getattr__方法<br />
print(s.name)</pre>
</div>
<p>运行结果是:</p>
<div>
<pre class="prettyprint linenums">/System/Library/Frameworks/Python.framework/Versions/3.4/bin/python3 /Users/lsf/PycharmProjects/py3Project/test3.py<br />
{'sex': 'male', 'name': 'alex'}<br />
alex

Process finished with exit code 0</pre>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/o8k1mmj9.html">Yii2 modal中 ajax提交表单</a>
		</li>
						<li><a href="https://www.batexi.com/a/jqdox6x8.html">jsessionid 导致重定向404的问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/0qw1o0k8.html">Go Walk教程 － 流程控制（ switch）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qde2dpz9.html">Appnium&plus;python实现手势密码为什么总是报错</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rdvwzr8.html">HDU 5417 Victor and Machine</a>
		</li>
						<li><a href="https://www.batexi.com/a/96p57w38.html">未来工厂&mdash;&mdash;电器行业ERP案例</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv1k22zq.html">CSS样式表之常用文本属性</a>
		</li>
						<li><a href="https://www.batexi.com/a/9r5zw5dq.html">Vue2全家桶之二：vue-router（路由）详细教程，看这个就够了</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gjvw2l9.html">C&num;  尝试读取或写入受保护的内存。这通常指示其他内存已损坏</a>
		</li>
						<li><a href="https://www.batexi.com/a/93w4wozq.html">particles&period;js使用及配置</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv24z0y9.html">bzoj4980&colon; 第一题</a>
		</li>
						<li><a href="https://www.batexi.com/a/q25ov0vq.html">css3 vw、vh属性详解，以及与&percnt;、rem的区别介绍</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7elg2j9.html">Qt中layout&lpar;&rpar;-&amp;gt&semi;setSizeConstraint&lpar;QLayout&colon;&colon;SetFixedSize&rpar;&semi;崩溃的问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jmd7kl9.html">BugPhobia回顾篇章：团队Alpha阶段工作分析</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4pwmo0q.html">基于TensorFlow Serving的深度学习在线预估</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o4wnplq.html">【Python】Django数据模型、级联删除、级联更新、ER图导出等</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mj4wrp8.html">从getApplicationContext和getApplication再次梳理Android的Application正确用法</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pprnnk9.html">java 通用对象排序</a>
		</li>
						<li><a href="https://www.batexi.com/a/95prd4eq.html">MySQL多版本并发控制机制&lpar;MVCC&rpar;-源码浅析</a>
		</li>
						<li><a href="https://www.batexi.com/a/8md2ngr8.html">mkvirtualenv创建python虚拟环境</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/rqlxek6q.html">NSTimer 定时器总结</a>
			</li>
						<li><a href="https://www.batexi.com/a/g8ex1meq.html">iOS运用fabric记录crash日志过程</a>
			</li>
						<li><a href="https://www.batexi.com/a/oqv7241q.html">关于&amp;lt&semi;appSettings file&equals;&amp;quot&semi;app&period;config&amp;quot&semi; &amp;gt&semi;引用外部文件的配置值</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9pvppd9.html">&num;一周五&num; VS2015 CTP6&comma; TFS2015 CTP1更新，老衣的开发工具汇总，2015 MVP 社区巡讲</a>
			</li>
						<li><a href="https://www.batexi.com/a/m96434y8.html">NSString与奇怪的retainCount</a>
			</li>
						<li><a href="https://www.batexi.com/a/2q7je3eq.html">yii2 gridview 是否显示某列案例</a>
			</li>
						<li><a href="https://www.batexi.com/a/3901dm38.html">Maven基础使用</a>
			</li>
						<li><a href="https://www.batexi.com/a/oqv7dgzq.html">十五天精通WCF&mdash;&mdash;第十一天 如何对wcf进行全程监控</a>
			</li>
						<li><a href="https://www.batexi.com/a/m8zlr3dq.html">Use Excel Pivot Table as a BI tool</a>
			</li>
						<li><a href="https://www.batexi.com/a/1q262m39.html">dyld&colon; Library not loaded&colon; &commat;rpath&sol;libswiftCore&period;dylib 解决方法</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
